#include <Windows.h>
#include <Windowsx.h>
#include <String.h>
#include "oleincl.h"
#include "Incline.h"

// ---- External functions from INCLINED.C
HANDLE MakeNative (HWND);
HANDLE MakeMetaFilePict (HWND);
HANDLE MakeOwnerLink (HWND);
HBITMAP MakeBitmap (HWND);
VOID PutsData (LPINCLINEDTEXT);

typedef LPVOID (FAR PASCAL *LPVOIDPROC) (LPOLEOBJECT, LPSTR);

//-------------------------------------------------------------
//					Initialization functions
//-------------------------------------------------------------

//						   ------------
// ----------------------- ServerAlloc  -----------------------
//						   ------------
// Allocates a TEXTSERVER structure, and initializes its fields

LPTEXTSERVER ServerAlloc (LPOLESERVERVTBL lpVtblSvr)
{
HANDLE			hmem;
LPTEXTSERVER	lpSvr;

	hmem = LocalAlloc (LPTR, sizeof (TEXTSERVER));
	if (!hmem)
		return FALSE;

	lpSvr = (LPTEXTSERVER)(PSTR)hmem;

	lpSvr->hmem = hmem;
	lpSvr->lpvtbl = lpVtblSvr;
	lpSvr->fRelease = TRUE;

	return lpSvr;
}

//						   ------------
// -----------------------   DocAlloc   -----------------------
//						   ------------
// Allocates a TEXTDOC structure, and initializes its fields

LPTEXTDOC DocAlloc (LPOLESERVERDOCVTBL lpVtblDoc)
{
HANDLE			hmem;
LPTEXTDOC		lpDoc;

	hmem = LocalAlloc (LPTR, sizeof (TEXTDOC));
	if (!hmem)
		return NULL;

	lpDoc = (LPTEXTDOC)(PSTR)hmem;

	lpDoc->hmem = hmem;
	lpDoc->fRelease = TRUE;
	lpDoc->lpvtbl = lpVtblDoc;

	return lpDoc;
}

//						   ------------
// -----------------------   ObjAlloc   -----------------------
//						   ------------
// Allocates a TEXTOBJECT structure, and initializes its fields

LPTEXTOBJECT ObjAlloc (LPOLEOBJECTVTBL lpVtblObj)
{
HANDLE			hmem;
LPTEXTOBJECT	lpObj;

	hmem = LocalAlloc (LPTR, sizeof (TEXTOBJECT));
	if (!hmem)
		return NULL;

	lpObj = (LPTEXTOBJECT)(PSTR)hmem;

	lpObj->hmem = hmem;
	lpObj->lpvtbl = lpVtblObj;
	lpObj->fRelease = TRUE;

	return lpObj;
}

//							 ----------
// -------------------------  WriteReg  -------------------
//                           ----------
// Writes in registration database

BOOL WriteReg (HINSTANCE hinst)
{
HKEY			hkServer;			// Server key
HKEY			hk;					// Key
char			szFic[256];			// Executable file name
char			szBuf[80], szBuf1[80];

	LoadString (hinst, IDS_KEY_SERVER, szBuf, sizeof szBuf);
	if (RegOpenKey (HKEY_CLASSES_ROOT, szBuf, &hkServer) == ERROR_SUCCESS)
	{
		RegCloseKey (hkServer);		// Already there
		return TRUE;
	}

// ---- Creates primary key - Inclined1.0 = Inclined Text
	LoadString (hinst, IDS_KEY_SERVER, szBuf, sizeof szBuf);
	if (RegCreateKey(HKEY_CLASSES_ROOT, szBuf, &hkServer) != ERROR_SUCCESS)
		return FALSE;
	LoadString (hinst, IDS_VAL_SERVER, szBuf, sizeof szBuf);
	RegSetValue (hkServer, NULL, REG_SZ, szBuf, lstrlen (szBuf));

// ---- Creates StdFileEditing key - Inclined1.0\protocol\StdFileEditing
	LoadString (hinst, IDS_KEY_STDFILE, szBuf, sizeof szBuf);
	if (RegCreateKey(hkServer, szBuf, &hk) != ERROR_SUCCESS)
		return FALSE;

// ---- And two subkeys - Inclined1.0\protocol\StdFileEditing\server = [exec path]
//						  Inclined1.0\protocol\StdFileEditing\verb\0 = Edit
	GetModuleFileName (hinst, szFic, sizeof szFic);
	LoadString (hinst, IDS_KEY_SERV, szBuf, sizeof szBuf);
	RegSetValue (hk, szBuf, REG_SZ, szFic, lstrlen (szFic));
	LoadString (hinst, IDS_KEY_VERB_0, szBuf, sizeof szBuf);
	LoadString (hinst, IDS_VAL_VERB_0, szBuf1, sizeof szBuf1);
	RegSetValue (hk, szBuf, REG_SZ, szBuf1, lstrlen (szBuf1));

// ---- Closes
	RegCloseKey (hkServer);
	RegCloseKey (hk);

// ---- User message
	LoadString (hinst, IDS_SAVE, szBuf, sizeof szBuf);
	LoadString (hinst, IDS_TITLE, szBuf1, sizeof szBuf1);
	MessageBox (GetFocus (), szBuf, szBuf1, MB_OK | MB_ICONEXCLAMATION);

	return TRUE;
}

//							 ----------
// ------------------------ RegClipboard --------------------
//                           ----------
// Registers clipboard formats

BOOL RegClipboard (VOID)
{
	OleGbl.cfNative = RegisterClipboardFormat ("Native");
	OleGbl.cfOwnerLink = RegisterClipboardFormat ("OwnerLink");

	return OleGbl.cfNative && OleGbl.cfOwnerLink;
}

//							 ----------
// ------------------------- RegServer --------------------
//                           ----------
// Creates TEXTSERVER structure and registers server

BOOL RegServer (HINSTANCE hinst)
{
char			szBuf[80];

// ---- Creates TEXTSERVER structure
	OleGbl.lpSvr = ServerAlloc (&OleGbl.vtblSvr);
	if (!OleGbl.lpSvr)
		return FALSE;

// ---- Registers server
	LoadString (hinst, IDS_KEY_SERVER, szBuf, sizeof szBuf);
	if (OleRegisterServer (szBuf, (LPOLESERVER)OleGbl.lpSvr, &OleGbl.lpSvr->lh, hinst,
						OLE_SERVER_MULTI) != OLE_OK)
	{
		LocalFree (OleGbl.lpSvr->hmem);
		return FALSE;
	}

	return TRUE;
}

//							 ----------
// ------------------------- CreateDoc  --------------------
//                           ----------
// Creates an initial document

BOOL CreateDoc (HINSTANCE hinst)
{
// ---- Creates document
	OleGbl.lpSvr->lpDoc = DocAlloc (&OleGbl.vtblDoc);	// Allocates a structure and initializes it
	if (!OleGbl.lpSvr->lpDoc)
	{
		LocalFree (OleGbl.lpSvr->lpDoc->hmem);
		OleRevokeServer (OleGbl.lpSvr->lh);
    	return FALSE;
    }

	return TRUE;
}

//							 ----------
// -------------------------  MyOleInit -------------------
//                           ----------
// Initialization called from WinMain

BOOL MyOleInit (HINSTANCE hinst, LPSTR lpCmdLine, WORD nCmdShow)
{
BOOL			InitVtbls (HINSTANCE);	// See end of source file

// ---- Registers in database
	if (!WriteReg (hinst))
		return FALSE;

// ---- Analyses command line
	_fstrupr (lpCmdLine);			// To upper
	AppGbl.fOle = _fstrstr (lpCmdLine, "-EMBEDDING") ||
				  _fstrstr (lpCmdLine, "/EMBEDDING");
	if (!AppGbl.fOle)
		return FALSE;				// Ends if standalone

// ---- Registers clipboard formats
	if (!RegClipboard ())
		return FALSE;

// ---- Initializes VTBLs
	if (!InitVtbls (hinst))
		return FALSE;

// ---- Creates TEXTSERVER structure and registers server
	if (!RegServer (hinst))
		return FALSE;

	OleGbl.lpSvr->fEmbed = AppGbl.fOle;
	OleGbl.lpSvr->fLink = FALSE;	// No linking, because no file save
	OleGbl.lpSvr->nCmdShow = AppGbl.fOle? SW_HIDE: nCmdShow;

// ---- Creates initial doc and registers it
	if (!CreateDoc (hinst))
		return FALSE;

	return TRUE;
}

//-------------------------------------------------------------
//					Other functions called from INCLINE.C
//-------------------------------------------------------------

//						   ------------
// -----------------------  MySaveDoc -----------------------
//						   ------------
// Tells OLESVR document has changed

BOOL MySaveDoc ()
{
	return OleSavedServerDoc (OleGbl.lpSvr->lpDoc->lh) == OLE_OK;
}

//						   ------------
// -----------------------   MyRevoke  -----------------------
//						   ------------
// Ends cleanly

VOID MyRevoke ()
{
MSG				msg;
BOOL			fMsg;

	if (OleRevokeServer (OleGbl.lpSvr->lh) == OLE_WAIT_FOR_RELEASE)
	{
		OleGbl.lpSvr->fRelease = FALSE;
		while (!OleGbl.lpSvr->fRelease)
		{
			OleUnblockServer (OleGbl.lpSvr->lh, &fMsg);
			if (!fMsg)
			{
				GetMessage (&msg, NULL, 0, 0);
				DispatchMessage (&msg);
			}
		}
	}
	return;
}

//						   ------------
// ----------------------- MyWaitShow  -----------------------
//						   ------------
// Wait for a call from ObjShow

VOID MyWaitShow ()
{
MSG				msg;
BOOL			fMsg;

	OleGbl.lpSvr->fObjShown = FALSE;
	while (!OleGbl.lpSvr->fObjShown)
	{
		OleUnblockServer (OleGbl.lpSvr->lh, &fMsg);
		if (!fMsg)
		{
			GetMessage (&msg, NULL, 0, 0);
			DispatchMessage (&msg);
		}
	}
	return;
}

//-------------------------------------------------------------
//						OLESERVERVTBL Callbacks
//-------------------------------------------------------------

//						   ------------
// ----------------------- ServerCreate -----------------------
//						   ------------
// Creates a new document

OLESTATUS FAR PASCAL _export ServerCreate (LPTEXTSERVER lpSvr,
						LHSERVERDOC lhDoc, LPSTR lpszClass, LPSTR lpszDoc,
						LPOLESERVERDOC FAR *lplpServerDoc)
{
LPTEXTDOC		lpDoc;

// ---- Creates a new document
	lpDoc = DocAlloc (&OleGbl.vtblDoc);
	if (!lpDoc)
    	return OLE_ERROR_NEW;

	lpSvr->lpDoc = lpDoc;
	lpDoc->lh = lhDoc;
	*lplpServerDoc = (LPOLESERVERDOC)lpDoc;

	return OLE_OK;
}

//					 ------------------------
// ----------------- ServerCreateFromTemplate ----------------
//					 ------------------------
// Creates a new document from a file

OLESTATUS FAR PASCAL _export ServerCreateFromTemplate(
						LPTEXTSERVER lpSvr, LHSERVERDOC lhDoc,
						LPSTR lpszClass, LPSTR lpszDoc, LPSTR lpszTemp,
						LPOLESERVERDOC FAR *lplpServerDoc)
{
	return OLE_ERROR_COMMAND;	// Not implemented here, because no file support
}

//						   ------------
// -----------------------  ServerEdit  -----------------------
//						   ------------
// Creates a new document initialized later

OLESTATUS FAR PASCAL _export ServerEdit (LPTEXTSERVER lpSvr,
						LHSERVERDOC lhDoc, LPSTR lpszClass, LPSTR lpszDoc,
						LPOLESERVERDOC FAR *lplpServerDoc)
{
LPTEXTDOC		lpDoc;

// ---- Creates a new document
	lpDoc = DocAlloc (&OleGbl.vtblDoc);
	if (!lpDoc)
    	return OLE_ERROR_NEW;

	lpSvr->lpDoc = lpDoc;
	lpDoc->lh = lhDoc;
	*lplpServerDoc = (LPOLESERVERDOC)lpDoc;

	return OLE_OK;
}

//						   ---------------
// -----------------------  ServerExecute ---------------------
//						   ---------------
// Executes a DDE command - Not implemented

OLESTATUS FAR PASCAL _export ServerExecute (LPTEXTSERVER lpSvr,
						HANDLE hCommands)
{
	return OLE_ERROR_COMMAND;
}

//						   ---------------
// -----------------------   ServerExit   ---------------------
//						   ---------------
// Ends in case of fatal error

OLESTATUS FAR PASCAL _export ServerExit (LPTEXTSERVER lpSvr)
{
	ShowWindow (AppGbl.hwnd, SW_HIDE);	// Hides window

	lpSvr->fRelease = FALSE;
	OleRevokeServer (lpSvr->lh);

	PostMessage (AppGbl.hwnd, WM_COMMAND, IDCANCEL, 0);	// End
	return OLE_OK;
}

//						   ---------------
// -----------------------   ServerOpen   ---------------------
//						   ---------------
// Opens a document - Not implemented here, because no file support

OLESTATUS FAR PASCAL _export ServerOpen (LPTEXTSERVER lpSvr,
						LHSERVERDOC lhDoc, LPSTR lpszDoc,
						LPOLESERVERDOC FAR *lplpServerDoc)
{
	return OLE_ERROR_COMMAND;
}

//						   ---------------
// -----------------------  ServerRelease ---------------------
//						   ---------------
// The end

OLESTATUS FAR PASCAL _export ServerRelease (LPTEXTSERVER lpSvr)
{
	if (lpSvr->lpDoc)
		if (lpSvr->lpDoc->hmem)
			LocalFree (lpSvr->lpDoc->hmem);

	lpSvr->lpDoc = NULL;
	lpSvr->fRelease = TRUE;

	if (!IsWindowVisible (AppGbl.hwnd))
		PostMessage (AppGbl.hwnd, WM_COMMAND, IDCANCEL, 0);	// End

	return OLE_OK;
}

//-------------------------------------------------------------
//						OLESERVERDOCVTBL Callbacks
//-------------------------------------------------------------

//						   ---------------
// -----------------------    DocClose     ---------------------
//						   ---------------
// Unconditional document close

OLESTATUS FAR PASCAL _export DocClose (LPTEXTDOC lpDoc)
{
    return OleRevokeServerDoc (lpDoc->lh);
}

//						   ---------------
// -----------------------  DocGetObject   ---------------------
//						   ---------------
// Asks for a OLEOBJECT structure creation

OLESTATUS FAR PASCAL _export DocGetObject (LPTEXTDOC lpDoc,
							LPSTR lpszItem, LPOLEOBJECT FAR *lplpObj,
							LPOLECLIENT lpClient)
{
LPTEXTOBJECT	lpObj;

	lpObj = ObjAlloc (&OleGbl.vtblObj);
	if (!lpObj)
		return OLE_ERROR_MEMORY;

	lpDoc->lpObj = lpObj;
	lpObj->lpClient = lpClient;

	*lplpObj = (LPOLEOBJECT)lpObj;

	return OLE_OK;
}

//						   ---------------
// -----------------------   DocExecute    ---------------------
//						   ---------------
// Executes a command - Not implemented

OLESTATUS FAR PASCAL _export DocExecute (LPTEXTDOC lpDoc, HANDLE hCommands)
{
	return OLE_ERROR_COMMAND;
}

//						   ---------------
// -----------------------   DocRelease    ---------------------
//						   ---------------
// Indicates a document can be destroyed

OLESTATUS FAR PASCAL _export DocRelease (LPTEXTDOC lpDoc)
{
	if (lpDoc->aObject)
	{
		DeleteAtom (lpDoc->aObject);
		lpDoc->aObject = NULL;
	}

	if (lpDoc->aClient)
	{
		DeleteAtom (lpDoc->aClient);
		lpDoc->aClient = NULL;
	}

	if (lpDoc->lpObj)
		if (lpDoc->lpObj->hmem)
			LocalFree (lpDoc->lpObj->hmem);
	lpDoc->lpObj = NULL;
	lpDoc->fRelease = TRUE;

	return OLE_OK;
}

//						   ---------------
// -----------------------    DocSave      ---------------------
//						   ---------------
// Asks for document saving - Not implemented

OLESTATUS FAR PASCAL _export DocSave (LPTEXTDOC lpDoc)
{
	return OLE_ERROR_COMMAND;
}

//						   ---------------
// ---------------------- DocSetColorScheme -----------------
//						   ---------------
// Indicates change in palette - Not implemented

OLESTATUS FAR PASCAL _export DocSetColorScheme (LPTEXTDOC lpDoc,
						LPLOGPALETTE lpPal)
{
	return OLE_ERROR_PALETTE;
}

//						   ---------------
// --------------------- DocSetDocDimension ----------------
//						   ---------------
// Asks for change in rectangle dimensions - Not implemented

OLESTATUS FAR PASCAL _export DocSetDocDimensions (LPTEXTDOC lpDoc,
						LPRECT lpRect)
{
	return OLE_ERROR_COMMAND;
}

//						   ---------------
// ----------------------- DocSetHostName  ----------------
//						   ---------------
// Asks for window title change

OLESTATUS FAR PASCAL _export DocSetHostNames (LPTEXTDOC lpDoc,
						LPSTR lpszClient, LPSTR lpszObj)
{
char			szBuf[256], szBuf1[80], szBuf2[80];

	LoadString (GetWindowInstance (AppGbl.hwnd), IDS_TITLE, szBuf2, sizeof szBuf2);
	LoadString (GetWindowInstance (AppGbl.hwnd), IDS_IN, szBuf1, sizeof szBuf1);
	wsprintf (szBuf, szBuf1, (LPSTR)szBuf2, lpszObj, lpszClient);
	SetWindowText (AppGbl.hwnd, szBuf);

// ---- Stores names
	if (lpDoc->aObject)
		DeleteAtom (lpDoc->aObject);
	lpDoc->aObject = AddAtom (lpszObj);

	if (lpDoc->aClient)
		DeleteAtom (lpDoc->aClient);
	lpDoc->aClient = AddAtom (lpszClient);

	return OLE_OK;
}

//-------------------------------------------------------------
//						OLESERVERDOCVTBL Callbacks
//-------------------------------------------------------------

//						   ---------------
// -----------------------    ObjDoVerb    ----------------
//						   ---------------
// Does an action on the object

OLESTATUS FAR PASCAL _export ObjDoVerb (LPTEXTOBJECT lpObj, WORD iVerb,
                               BOOL fShow, BOOL fFocus)
{
	switch (iVerb)
	{
	case 0:							// Edit
		if (fShow)					// Callq Show method
			return (lpObj->lpvtbl->Show)((LPOLEOBJECT)lpObj, fShow);
		break;

	case 1:							// Play
		return OLE_ERROR_DOVERB;

	default:
		return OLE_ERROR_DOVERB;
	}

	return OLE_OK;
}

//						   ---------------
// ----------------------- ObjEnumFormats  ---------------
//						   ---------------
// Returns next clipboard format

OLECLIPFORMAT FAR PASCAL _export ObjEnumFormats (LPTEXTOBJECT lpObj, WORD cf)
{
	if (cf == 0)
		return OleGbl.cfNative;

	if (cf == OleGbl.cfNative)
		return OleGbl.cfOwnerLink;

	if (cf == OleGbl.cfOwnerLink)
		return CF_METAFILEPICT;

	if (cf == CF_METAFILEPICT)
		return CF_BITMAP;

	if (cf == CF_BITMAP)
		return NULL;

	return NULL;
}

//						   ---------------
// -----------------------   ObjGetData    ---------------
//						   ---------------
// Returns the data in a given format

OLESTATUS FAR PASCAL _export ObjGetData (LPTEXTOBJECT lpObj,
						WORD cf, LPHANDLE lphData)
{
	if (cf == OleGbl.cfNative)
		*lphData = MakeNative (AppGbl.hwnd);

	else if (cf == CF_METAFILEPICT)
		*lphData = MakeMetaFilePict (AppGbl.hwnd);

	else if (cf == CF_BITMAP)
		*lphData = MakeBitmap (AppGbl.hwnd);

	else if (cf == OleGbl.cfOwnerLink)
		*lphData = MakeOwnerLink (AppGbl.hwnd);

	if (!*lphData)
		return OLE_ERROR_MEMORY;

	return OLE_OK;
}

//						   ---------------
// ----------------------- ObjQueryProtocol ---------------
//						   ---------------
// Returns a pointer on TEXTOBJECT for StdFileEditing

LPVOID FAR PASCAL _export ObjQueryProtocol (LPTEXTOBJECT lpObj,
						LPSTR lpszProtocol)
{
	if (!lstrcmp (lpszProtocol, "StdEditing"))
		return (LPVOID)lpObj;

	return NULL;
}

//						   ---------------
// -----------------------    ObjRelease   -----------------
//						   ---------------
// Indicates object resources freed

OLESTATUS FAR PASCAL _export ObjRelease (LPTEXTOBJECT lpObj)
{
	lpObj->fRelease = TRUE;
	lpObj->lpClient = NULL;

	return OLE_OK;
}

//						   ---------------
// -----------------------   ObjSetBounds  -----------------
//						   ---------------
// Indicates new rectangle

OLESTATUS FAR PASCAL _export ObjSetBounds (LPTEXTOBJECT lpObj, LPRECT lpRect)
{
	return OLE_OK;
}

//						   ---------------
// ----------------------- ObjSetColorScheme --------------
//						   ---------------
// Indicates new palette

OLESTATUS FAR PASCAL _export ObjSetColorScheme (LPTEXTOBJECT lpObj,
							LPLOGPALETTE lpPal)
{
	return OLE_ERROR_PALETTE;
}

//						   ---------------
// -----------------------   ObjSetData    -----------------
//						   ---------------
// New data for object

OLESTATUS FAR PASCAL _export ObjSetData (LPTEXTOBJECT lpObj,
							WORD cf, HANDLE hData)
{
LPINCLINEDTEXT	lpti;

	if (cf != OleGbl.cfNative)		// Only Native format supported
		return OLE_ERROR_FORMAT;

	lpti = (LPINCLINEDTEXT)GlobalLock (hData);
	if (!lpti)
		return OLE_ERROR_MEMORY;

	PutsData (lpti);

// ---- Frees
	GlobalUnlock (hData);
	GlobalFree (hData);
	return OLE_OK;
}

//						   ---------------
// ---------------------- ObjSetTargetDevice ------------------
//						   ---------------
// Gives informations on client device

OLESTATUS FAR PASCAL _export ObjSetTargetDevice (LPTEXTOBJECT lpObj,
						HANDLE hData)
{
	if (hData)
		GlobalFree(hData);

	return OLE_OK;
}

//						   ---------------
// -----------------------    ObjShow      -----------------
//						   ---------------
// Makes object visible

OLESTATUS FAR PASCAL _export ObjShow (LPTEXTOBJECT lpObj, BOOL fTakeFocus)
{
	ShowWindow (AppGbl.hwnd, SW_NORMAL);
	if (fTakeFocus)
		SetFocus(AppGbl.hwnd);
	OleGbl.lpSvr->fObjShown = TRUE;

	return OLE_OK;
}


//							 ----------
// ------------------------  InitVtbls  --------------------
//                           ----------
// Initializes VTBLs

BOOL InitVtbls (HINSTANCE hinst)
{
	OleGbl.vtblSvr.Create			= MakeProcInstance (ServerCreate, hinst);
	OleGbl.vtblSvr.CreateFromTemplate= MakeProcInstance (ServerCreateFromTemplate, hinst);
	OleGbl.vtblSvr.Edit				= MakeProcInstance (ServerEdit, hinst);
	OleGbl.vtblSvr.Execute			= MakeProcInstance (ServerExecute, hinst);
	OleGbl.vtblSvr.Exit				= MakeProcInstance (ServerExit, hinst);
	OleGbl.vtblSvr.Open				= MakeProcInstance (ServerOpen, hinst);
	OleGbl.vtblSvr.Release			= MakeProcInstance (ServerRelease, hinst);

	OleGbl.vtblDoc.Close			= MakeProcInstance (DocClose, hinst);
	OleGbl.vtblDoc.GetObject		= MakeProcInstance (DocGetObject, hinst);
	OleGbl.vtblDoc.Execute			= MakeProcInstance (DocExecute, hinst);
	OleGbl.vtblDoc.Release			= MakeProcInstance (DocRelease, hinst);
	OleGbl.vtblDoc.Save				= MakeProcInstance (DocSave, hinst);
	OleGbl.vtblDoc.SetColorScheme	= MakeProcInstance (DocSetColorScheme, hinst);
	OleGbl.vtblDoc.SetDocDimensions	= MakeProcInstance (DocSetDocDimensions, hinst);
	OleGbl.vtblDoc.SetHostNames		= MakeProcInstance (DocSetHostNames, hinst);

	OleGbl.vtblObj.QueryProtocol	= (LPVOIDPROC)MakeProcInstance ((FARPROC)ObjQueryProtocol, hinst);
	OleGbl.vtblObj.DoVerb			= MakeProcInstance (ObjDoVerb, hinst);
	OleGbl.vtblObj.EnumFormats		= MakeProcInstance (ObjEnumFormats, hinst);
	OleGbl.vtblObj.GetData			= MakeProcInstance (ObjGetData, hinst);
	OleGbl.vtblObj.Release			= MakeProcInstance (ObjRelease, hinst);
	OleGbl.vtblObj.SetBounds		= MakeProcInstance (ObjSetBounds, hinst);
	OleGbl.vtblObj.SetColorScheme	= MakeProcInstance (ObjSetColorScheme, hinst);
	OleGbl.vtblObj.SetData			= MakeProcInstance (ObjSetData, hinst);
	OleGbl.vtblObj.SetTargetDevice	= MakeProcInstance (ObjSetTargetDevice, hinst);
	OleGbl.vtblObj.Show				= MakeProcInstance (ObjShow, hinst);

	return
		OleGbl.vtblSvr.Create &&
		OleGbl.vtblSvr.CreateFromTemplate &&
		OleGbl.vtblSvr.Edit &&
		OleGbl.vtblSvr.Execute &&
		OleGbl.vtblSvr.Exit &&
		OleGbl.vtblSvr.Open &&
		OleGbl.vtblSvr.Release &&

		OleGbl.vtblDoc.Close &&
		OleGbl.vtblDoc.GetObject &&
		OleGbl.vtblDoc.Execute &&
		OleGbl.vtblDoc.Release &&
		OleGbl.vtblDoc.Save &&
		OleGbl.vtblDoc.SetColorScheme &&
		OleGbl.vtblDoc.SetDocDimensions &&
		OleGbl.vtblDoc.SetHostNames &&

		OleGbl.vtblObj.QueryProtocol &&
		OleGbl.vtblObj.DoVerb &&
		OleGbl.vtblObj.EnumFormats &&
		OleGbl.vtblObj.GetData &&
		OleGbl.vtblObj.Release &&
		OleGbl.vtblObj.SetBounds &&
		OleGbl.vtblObj.SetColorScheme &&
		OleGbl.vtblObj.SetData &&
		OleGbl.vtblObj.SetTargetDevice &&
		OleGbl.vtblObj.Show;
}
